function Xhat = sIRLSp(X,mask,p)
% Schatten p-norm minimization for matrix completion using IRLS
% 
% Syntax:       Xhat = sIRLSp(X,mask,p)
%
% Inputs:       X is a matrix of size (M x N)
%               mask is a logical-valued matrix of sampling locations of size (M x N)
%               p is the norm to minimize
%
% Outputs:      Xhat is a completed estimate of X of size (M x N)

[M,N] = size(X);

%% Your code starts here

% algorithm parameters - some not given here
tol = 1e-8;
maxIter = 1000;


for kk = 1:maxIter

    % stopping condition
    err = norm(Xprev - Xhat,'fro')/norm(Xhat,'fro');
    if err < tol
        break
    end
end
