"""
LMRC demo - syntheticTest

ECE 510

python version: 3.7.3

Spring 2019
"""

import numpy as np
from numpy.random import randn, rand
from numpy.linalg import norm 
from sIRLSp import sIRLSp


M = 100
N = 100
r = 5

## true data matrix
Xtrue = randn(M, r) @ randn(r, N)

## create mask to sample samProb percent of entries
sampProb = 0.4
mask = rand(M, N) < sampProb 
X = Xtrue * mask

## run you algorithm
p = 1
Xhat = sIRLSp(X, mask, p)
err = norm(Xhat - Xtrue, ord='fro')/norm(Xtrue, ord='fro')
print(f"Estimated error:{err}")
